void arrow(float x,  float y, float radius, float angle,PGraphics pg) {
  pg.beginDraw();
  if((radius<5)) {
    pg.fill(0); 
    pg.ellipse(x,y, 4,4);
  }
  else {
    pg.pushMatrix();
    pg.translate(x, y);
    // pg.translate((x+cos(angle)*radius)/2, (y+sin(angle)*radius)/2);
    pg.rotate(angle);
    pg.line(-radius/2, 0, radius/2, 0);
    if (radius>=0) {
      pg.translate(radius/2, 0);
      pg.rotate(-PI/2);
      pg.line(0, 0, -3, -6);
      pg.line(0, 0, 3, -6);
    }
    else {
      pg.translate(radius/2, 0);
      pg.rotate(-PI/2);
      pg.line(0, 0, 3, 6);
      pg.line(0, 0, -3, 6);
    }          
    pg.popMatrix();
  }
  pg.endDraw();
} 

void arrow0(float x,  float y, float radius, float angle,PGraphics pg) {
  pg.beginDraw();
  if(abs(radius)>4) {
    pg.pushMatrix();
    pg.translate(x, y);
    // pg.translate((x+cos(angle)*radius)/2, (y+sin(angle)*radius)/2);
    pg.rotate(angle);
    pg.line(-radius/2, 0, radius/2, 0);
    if (radius>=0) {
      pg.translate(radius/2, 0);
      pg.rotate(-PI/2);
      pg.line(0, 0, -3, -6);
      pg.line(0, 0, 3, -6);
    }
    else {
      pg.translate(radius/2, 0);
      pg.rotate(-PI/2);
      pg.line(0, 0, 3, 6);
      pg.line(0, 0, -3, 6);
    }          
    pg.popMatrix();

    pg.endDraw();
  }
} 

void arrow0_(float x,  float y, float radius, float angle,PGraphics pg) {
  pg.beginDraw();
  if(abs(radius)>4) {
    pg.pushMatrix();
    pg.translate(x, y);
    // pg.translate((x+cos(angle)*radius)/2, (y+sin(angle)*radius)/2);
    pg.rotate(angle);
    pg.line(-radius/2, 0, radius/2, 0);
    if (radius>=0) {
      pg.translate(radius/2, 0);
      pg.rotate(-PI/2);
      pg.line(0, 0, -3, -6);
      pg.line(0, 0, 3, -6);
    }
    else {
      pg.translate(radius/2, 0);
      pg.rotate(-PI/2);
      pg.line(0, 0, 3, 6);
      pg.line(0, 0, -3, 6);
    }          
    pg.popMatrix();
  }
  else {
    pg.fill(0); 
    pg.ellipse(x,y, 4,4);
  }
  pg.endDraw();
}     


void arrowline(float x1, float  y1, float x2,float y2, PGraphics pg) {
  pg.beginDraw();      
  if(dist(x1,y1,x2,y2)>5) {
     pg.line(x1, y1, x2, y2);
    pg.pushMatrix();
    pg.translate(x2, y2);
    float a = atan2(x1-x2, y2-y1);
    pg.rotate(a);

    pg.line(0, 0, -3, -6);
    pg.line(0, 0, 3, -6);
    pg.popMatrix();
  }
  pg.endDraw();
} 

void arrowline_(float x1, float  y1, float x2,float y2, PGraphics pg) {
  pg.beginDraw();      
  if(dist(x1,y1,x2,y2)>5) {
     pg.line(x1, y1, x2, y2);
    pg.pushMatrix();
    pg.translate(x2, y2);
    float a = atan2(x1-x2, y2-y1);
    pg.rotate(a);

    pg.line(0, 0, -3, -6);
    pg.line(0, 0, 3, -6);
    pg.popMatrix();
  }else{
        pg.fill(0); 
    pg.ellipse(x1,y1, 4,4);
  }
  pg.endDraw();
} 
